#include <iostream>
#include <iomanip>
using namespace std;

#define LINHAS    3
#define COLUNAS   3

class Matrix {
  int **mat;
  int linhas, colunas;

public:
  Matrix();
  Matrix(int lins, int cols);
  Matrix(int **newmat, int lins, int cols);
  void entrada();
  void saida();
  int getElement(int i, int k) const;
  Matrix operator +(const Matrix& mat2) const;
  Matrix operator -(const Matrix& mat2) const;
  Matrix operator *(const Matrix& mat2) const;
  Matrix operator *(int escalar) const;
};


Matrix::Matrix()
{
  int i, k;

  linhas = LINHAS;
  colunas = COLUNAS;

  mat = new int* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new int(colunas);
    for (k=0; k < colunas; k++)
      mat[i][k] = 0;
  }
}

Matrix::Matrix(int lins, int cols)
{
  int i, k;

  linhas = lins;
  colunas = cols;

  mat = new int* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new int(colunas);
    for (k=0; k < colunas; k++)
      mat[i][k] = 0;
  }
}

Matrix::Matrix(int **newmat, int lins, int cols)
{
  int i, k;

  linhas = lins;
  colunas = cols;

  mat = new int* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new int(colunas);
    for (k=0; k < colunas; k++)
      mat[i][k] = newmat[i][k];
  }
}

void Matrix::entrada ()
{
  int i, k;
  for (i=0; i < linhas; i++) {
    for (k=0; k < colunas; k++) {
      cout << "\t elemento (" << i << "," << k << "): ";
      cin >> mat[i][k];
    }
  }
}

void Matrix::saida ()
{
  int i, k;
  for (i=0; i < linhas; i++) {
    //    cout.setf(ios::showpoint|ios::fixed);
    //    cout.precision(2);
    for (k=0; k < colunas; k++)
      cout << setw(5) << mat[i][k] << "\t";
    cout << endl;
  }
}

int Matrix::getElement(int i, int k) const
{
  return (mat[i][k]);
}

Matrix Matrix::operator+ (const Matrix& mat_2) const
{
  int i, k;
  int **soma = new int* [linhas];

  for (i=0; i < linhas; i++)
    soma[i] = new int [colunas];

  for (i=0; i < linhas; i++)
    for (k=0; k < colunas; k++)
      soma[i][k] = mat[i][k] + mat_2.mat[i][k];
  
  return (Matrix(soma, linhas, colunas));
}

Matrix Matrix::operator- (const Matrix& mat_2) const
{
  int i, k;
  int **soma = new int* [linhas];

  for (i=0; i < linhas; i++)
    soma[i] = new int [colunas];

  for (i=0; i < linhas; i++)
    for (k=0; k < colunas; k++)
      soma[i][k] = mat[i][k] - mat_2.mat[i][k];
  
  return (Matrix(soma, linhas, colunas));
}


Matrix Matrix::operator* (int escalar) const
{
  int i, k;
  int **prod = new int* [linhas];

  for (i=0; i < linhas; i++)
    prod[i] = new int [colunas];

  for (i=0; i < linhas; i++)
    for (k=0; k < colunas; k++)
      prod[i][k] = escalar * mat[i][k];
  
  return (Matrix(prod, linhas, colunas));
}

Matrix Matrix::operator* (const Matrix& mat_2) const
{
  int i,j,p,q;
  int **prod = new int* [linhas];

  for (i=0; i < linhas; i++) {
    prod[i] = new int [mat_2.colunas];
    for (j=0; j < mat_2.colunas; j++)
      prod[i][j] = 0;
  }

  for (i=0; i < linhas; i++)
    for (j=0; j < mat_2.colunas; j++) {
      for (p=0; p < colunas; p++)
	prod[i][j] += mat[i][p] * mat_2.mat[p][j];
    }
  
  return (Matrix(prod, linhas, mat_2.colunas));
}



main () 
{
  Matrix matriz(6,6), soma(6,6), result(6,6);

  cout << "Forneca os valores da Matriz 1:\n";
  matriz.entrada();
  cout << "\n\n";
  cout << "Forneca os valores da Matriz 2:\n";
  soma.entrada();

  result = matriz * soma;
  cout << "\n\nProduto das matrizes = \n";
  result.saida();

  result = matriz * 4;
  cout << "\n\nProduto da Matriz 1 pelo escalar 4 = \n";
  result.saida();

  result = soma + matriz;
  cout << "\n\nSoma das matrizes = \n";
  result.saida();
}

